SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sf::InputStream Class Referenceabstract
System module

Abstract class for custom file input streams. More...

`#include <InputStream.hpp>`

## Public Member Functions
virtual | ~InputStream ()
| Virtual destructor. More...
virtual Int64 | read (void *data, Int64 size)=0
| Read data from the stream. More...
virtual Int64 | seek (Int64 position)=0
| Change the current reading position. More...
virtual Int64 | tell ()=0
| Get the current reading position in the stream. More...
virtual Int64 | getSize ()=0
| Return the size of the stream. More...

## Detailed Description

Abstract class for custom file input streams.

This class allows users to define their own file input sources from which SFML can load resources.

SFML resource classes like sf::Texture and sf::SoundBuffer provide loadFromFile and loadFromMemory functions, which read data from conventional sources. However, if you have data coming from a different source (over a network, embedded, encrypted, compressed, etc) you can derive your own class from sf::InputStream and load SFML resources with their loadFromStream function.

Usage example:

// custom stream class that reads from inside a zip file
class ZipStream : public sf::InputStream
{
public :
ZipStream(std::string archive);
bool open(std::string filename);
Int64 read(void* data, Int64 size);
Int64 seek(Int64 position);
Int64 tell();
Int64 getSize();
private :
...
};
// now you can load textures...
sf::Texture texture;
ZipStream stream("resources.zip");
stream.open("images/img.png");
texture.loadFromStream(stream);
// musics...
sf::Music music;
ZipStream stream("resources.zip");
stream.open("musics/msc.ogg");
music.openFromStream(stream);
// etc.

Definition at line 40 of file InputStream.hpp.

## Constructor & Destructor Documentation

virtual sf::InputStream::~InputStream | ( | ) |  |
| inline virtual

Virtual destructor.

Definition at line 48 of file InputStream.hpp.

## Member Function Documentation

virtual Int64 sf::InputStream::getSize | ( | ) |  |
| pure virtual

Return the size of the stream.

Returns
  The total number of bytes available in the stream, or -1 on error

virtual Int64 sf::InputStream::read | ( | void * | data,
|  | Int64 | size
| ) |  |
| pure virtual

Read data from the stream.

After reading, the stream's reading position must be advanced by the amount of bytes read.

Parameters

  data | Buffer where to copy the read data
  size | Desired number of bytes to read

Returns
  The number of bytes actually read, or -1 on error

virtual Int64 sf::InputStream::seek | ( | Int64 | position) |  |
| pure virtual

Change the current reading position.

Parameters

  position | The position to seek to, from the beginning

Returns
  The position actually sought to, or -1 on error

virtual Int64 sf::InputStream::tell | ( | ) |  |
| pure virtual

Get the current reading position in the stream.

Returns
  The current position, or -1 on error.

The documentation for this class was generated from the following file:

- InputStream.hpp